﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Threading;

namespace pr243_1
{
    // Класс для создания объекта: 
    class MyClass {
        // Открытое целочисленное поле: 
        public int state = 0;
    }

    // Класс с главным методом: 
    class Program
    {
        // Метод для выполнения в потоке: 
        static void run(bool type, MyClass obj) {
            // Целочисленные переменные: 
            int val, k = 1;
            // Объект для генерации случайных чисел:
            Random rnd = new Random();
            // Конструкция цикла: 
            while(k <= 5) {
                // Блокировка объекта: 
                //lock(obj) {
                    // Считывание значения поля: 
                    val = obj.state;
                    // Отображение прочитанного значения:
                    Console.WriteLine("{0,4}: прочитано значение {1,2}", 
                        Thread.CurrentThread.Name, val);
                    // Случайная задержка в выполнении потока: 
                    Thread.Sleep(rnd.Next(1000, 3001));
                    // Новое значение переменной: 
                    if (type) val++; else val--;
                    // Полю объекта присваивается новое значение: 
                    obj.state = val;
                    // Отображение нового значения поля:
                    Console.WriteLine("{0,4}: присвоено значение {1,2}", 
                        Thread.CurrentThread.Name, obj.state);
                    // Новое значение индексной переменной: 
                    k++;
                //}
            }
        }

        // Главный метод:
        static void Main()
        {
            // Создание объекта:
            MyClass obj = new MyClass();
            // Объект первого потока:
            Thread up = new Thread(() => run(true, obj));
            // Название первого потока: 
            up.Name = "UP";
            // Создание объекта второго потока:
            Thread down = new Thread(() => run(false, obj));
            // Название второго потока: 
            down.Name = "DOWN";
            // Запуск первого потока на выполнение: 
            up.Start();
            // Запуск второго потока на выполнение: 
            down.Start();
        }
    }
}
